/*----- PROTECTED REGION ID(CbpmMasterClass.cpp) ENABLED START -----*/
static const char *RcsId      = "$Id: CbpmMasterClass.cpp,v 1.4 2018-04-24 15:32:51 giulio Exp $";
static const char *TagName    = "$Name: release_11 $";
static const char *CvsPath    = "$Source: /home/cvsadm/cvsroot/fermi/servers/cbpmmaster/src/CbpmMasterClass.cpp,v $";
static const char *SvnPath    = "$HeadURL:  $";
static const char *HttpServer = "http://www.esrf.eu/computing/cs/tango/tango_doc/ds_doc/";
//=============================================================================
//
// file :        CbpmMasterClass.cpp
//
// description : C++ source for the CbpmMasterClass. A singleton
//               class derived from DeviceClass. It implements the
//               command list and all properties and methods required
//               by the name once per process.
//
// project :     Cbpm Master.
//
// $Author: giulio $
//
// $Revision: 1.4 $
// $Date: 2018-04-24 15:32:51 $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source: /home/cvsadm/cvsroot/fermi/servers/cbpmmaster/src/CbpmMasterClass.cpp,v $
// $Log: CbpmMasterClass.cpp,v $
// Revision 1.4  2018-04-24 15:32:51  giulio
// Added Agc/Avc decimation values
//
// Revision 1.3  2018-04-19 08:17:56  giulio
// Automatic reset of the lantronix switches through the pdu's
//
// Revision 1.2  2014-05-05 07:33:57  giulio
// Added rtbpm switch
//
// Revision 1.1.1.1  2012-04-16 12:45:50  giulio
// First release
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <CbpmMasterClass.h>

/*----- PROTECTED REGION END -----*/	//	CbpmMasterClass.cpp

//-------------------------------------------------------------------
/**
 *	Create CbpmMasterClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_CbpmMaster_class(const char *name) {
		return CbpmMaster_ns::CbpmMasterClass::init(name);
	}
}

namespace CbpmMaster_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
CbpmMasterClass *CbpmMasterClass::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		CbpmMasterClass::CbpmMasterClass(string &s)
 * description : 	constructor for the CbpmMasterClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
CbpmMasterClass::CbpmMasterClass(string &s):Tango::DeviceClass(s)
{
	cout2 << "Entering CbpmMasterClass constructor" << endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(CbpmMasterClass::constructor) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	CbpmMasterClass::constructor

	cout2 << "Leaving CbpmMasterClass constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		CbpmMasterClass::~CbpmMasterClass()
 * description : 	destructor for the CbpmMasterClass
 */
//--------------------------------------------------------
CbpmMasterClass::~CbpmMasterClass()
{
	/*----- PROTECTED REGION ID(CbpmMasterClass::destructor) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	CbpmMasterClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		CbpmMasterClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
CbpmMasterClass *CbpmMasterClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new CbpmMasterClass(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}		
	}		
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		CbpmMasterClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
CbpmMasterClass *CbpmMasterClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		ForceFel01Class::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ForceFel01Class::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "ForceFel01Class::execute(): arrived" << endl;
	((static_cast<CbpmMaster *>(device))->force_fel01());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		ForceFel02Class::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ForceFel02Class::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "ForceFel02Class::execute(): arrived" << endl;
	((static_cast<CbpmMaster *>(device))->force_fel02());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		GetCbpmFel01NamesClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetCbpmFel01NamesClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "GetCbpmFel01NamesClass::execute(): arrived" << endl;
	return insert((static_cast<CbpmMaster *>(device))->get_cbpm_fel01_names());
}

//--------------------------------------------------------
/**
 * method : 		GetCbpmFel02NamesClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetCbpmFel02NamesClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "GetCbpmFel02NamesClass::execute(): arrived" << endl;
	return insert((static_cast<CbpmMaster *>(device))->get_cbpm_fel02_names());
}

//--------------------------------------------------------
/**
 * method : 		GetBpmFel01NamesClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetBpmFel01NamesClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "GetBpmFel01NamesClass::execute(): arrived" << endl;
	return insert((static_cast<CbpmMaster *>(device))->get_bpm_fel01_names());
}

//--------------------------------------------------------
/**
 * method : 		GetBpmFel02NamesClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetBpmFel02NamesClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "GetBpmFel02NamesClass::execute(): arrived" << endl;
	return insert((static_cast<CbpmMaster *>(device))->get_bpm_fel02_names());
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : CbpmMasterClass::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum CbpmMasterClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : CbpmMasterClass::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum CbpmMasterClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : CbpmMasterClass::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum CbpmMasterClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : CbpmMasterClass::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void CbpmMasterClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
	prop_name = "PlcDevice";
	prop_desc = "Plc device name used to get information about fel01/02 status";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Fel01CbpmDevices";
	prop_desc = "Fel01 cbpm devices";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Fel02CbpmDevices";
	prop_desc = "Fel02 cbpm devices";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "CheckPeriod";
	prop_desc = "seconds";
	prop_def  = "10";
	vect_data.clear();
	vect_data.push_back("10");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "SwitchTcpPort";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "SwitchTcpAddress";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Fel01BpmDevices";
	prop_desc = "Fel01 bpm devices";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Fel02BpmDevices";
	prop_desc = "Fel02 bpm devices";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "SwitchPDU";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method      : CbpmMasterClass::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void CbpmMasterClass::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("Cbpm Master");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("Enable/disable cbpm's depending on fel01/fel02 configuration");
	description << str_desc;
	data.push_back(description);

	//	put cvs or svn location
	string	filename("CbpmMaster");
	filename += "Class.cpp";

	// check for cvs information
	string	src_path(CvsPath);
	start = src_path.find("/");
	if (start!=string::npos)
	{
		end   = src_path.find(filename);
		if (end>start)
		{
			string	strloc = src_path.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	// check for svn information
	else
	{
		string	src_path(SvnPath);
		start = src_path.find("://");
		if (start!=string::npos)
		{
			end = src_path.find(filename);
			if (end>start)
			{
				header = "$HeadURL: ";
				start = header.length();
				string	strloc = src_path.substr(start, (end-start));
				
				Tango::DbDatum	svn_loc("svn_location");
				svn_loc << strloc;
				data.push_back(svn_loc);
			}
		}
	}

	//	Get CVS or SVN revision tag
	
	// CVS tag
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}
	
	// SVN tag
	string	svnpath(SvnPath);
	header = "$HeadURL: ";
	start = header.length();
	
	end   = svnpath.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strloc = svnpath.substr(start, end-start);
		
		string tagstr ("/tags/");
		start = strloc.find(tagstr);
		if ( start!=string::npos )
		{
			start = start + tagstr.length();
			end   = strloc.find(filename);
			string	strtag = strloc.substr(start, end-start-1);
			
			Tango::DbDatum	svn_tag("svn_tag");
			svn_tag << strtag;
			data.push_back(svn_tag);
		}
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : CbpmMasterClass::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void CbpmMasterClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(CbpmMasterClass::device_factory_before) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	CbpmMasterClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new CbpmMaster(this, (*devlist_ptr)[i]));							 
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		CbpmMaster *dev = static_cast<CbpmMaster *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(CbpmMasterClass::device_factory_after) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	CbpmMasterClass::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : CbpmMasterClass::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void CbpmMasterClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(CbpmMasterClass::attribute_factory_before) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	CbpmMasterClass::attribute_factory_before
	//	Attribute : Enabled
	EnabledAttrib	*enabled = new EnabledAttrib();
	Tango::UserDefaultAttrProp	enabled_prop;
	enabled_prop.set_description("Enable automatic switching");
	//	label	not set for Enabled
	//	unit	not set for Enabled
	//	standard_unit	not set for Enabled
	//	display_unit	not set for Enabled
	//	format	not set for Enabled
	//	max_value	not set for Enabled
	//	min_value	not set for Enabled
	//	max_alarm	not set for Enabled
	//	min_alarm	not set for Enabled
	//	max_warning	not set for Enabled
	//	min_warning	not set for Enabled
	//	delta_t	not set for Enabled
	//	delta_val	not set for Enabled
	
	enabled->set_default_properties(enabled_prop);
	enabled->set_polling_period(1000);
	enabled->set_disp_level(Tango::OPERATOR);
	enabled->set_memorized();
	enabled->set_memorized_init(true);
	att_list.push_back(enabled);

	//	Attribute : Fel01
	Fel01Attrib	*fel01 = new Fel01Attrib();
	Tango::UserDefaultAttrProp	fel01_prop;
	//	description	not set for Fel01
	//	label	not set for Fel01
	//	unit	not set for Fel01
	//	standard_unit	not set for Fel01
	//	display_unit	not set for Fel01
	//	format	not set for Fel01
	//	max_value	not set for Fel01
	//	min_value	not set for Fel01
	//	max_alarm	not set for Fel01
	//	min_alarm	not set for Fel01
	//	max_warning	not set for Fel01
	//	min_warning	not set for Fel01
	//	delta_t	not set for Fel01
	//	delta_val	not set for Fel01
	
	fel01->set_default_properties(fel01_prop);
	//	Not Polled
	fel01->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(fel01);

	//	Attribute : Fel02
	Fel02Attrib	*fel02 = new Fel02Attrib();
	Tango::UserDefaultAttrProp	fel02_prop;
	//	description	not set for Fel02
	//	label	not set for Fel02
	//	unit	not set for Fel02
	//	standard_unit	not set for Fel02
	//	display_unit	not set for Fel02
	//	format	not set for Fel02
	//	max_value	not set for Fel02
	//	min_value	not set for Fel02
	//	max_alarm	not set for Fel02
	//	min_alarm	not set for Fel02
	//	max_warning	not set for Fel02
	//	min_warning	not set for Fel02
	//	delta_t	not set for Fel02
	//	delta_val	not set for Fel02
	
	fel02->set_default_properties(fel02_prop);
	//	Not Polled
	fel02->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(fel02);

	//	Attribute : AvcValMin
	AvcValMinAttrib	*avcvalmin = new AvcValMinAttrib();
	Tango::UserDefaultAttrProp	avcvalmin_prop;
	//	description	not set for AvcValMin
	//	label	not set for AvcValMin
	//	unit	not set for AvcValMin
	//	standard_unit	not set for AvcValMin
	//	display_unit	not set for AvcValMin
	avcvalmin_prop.set_format("%.0f");
	avcvalmin_prop.set_max_value("100000");
	avcvalmin_prop.set_min_value("0");
	//	max_alarm	not set for AvcValMin
	//	min_alarm	not set for AvcValMin
	//	max_warning	not set for AvcValMin
	//	min_warning	not set for AvcValMin
	//	delta_t	not set for AvcValMin
	//	delta_val	not set for AvcValMin
	
	avcvalmin->set_default_properties(avcvalmin_prop);
	//	Not Polled
	avcvalmin->set_disp_level(Tango::OPERATOR);
	avcvalmin->set_memorized();
	avcvalmin->set_memorized_init(true);
	att_list.push_back(avcvalmin);

	//	Attribute : AvcValMax
	AvcValMaxAttrib	*avcvalmax = new AvcValMaxAttrib();
	Tango::UserDefaultAttrProp	avcvalmax_prop;
	//	description	not set for AvcValMax
	//	label	not set for AvcValMax
	//	unit	not set for AvcValMax
	//	standard_unit	not set for AvcValMax
	//	display_unit	not set for AvcValMax
	avcvalmax_prop.set_format("%.0f");
	avcvalmax_prop.set_max_value("100000");
	avcvalmax_prop.set_min_value("0");
	//	max_alarm	not set for AvcValMax
	//	min_alarm	not set for AvcValMax
	//	max_warning	not set for AvcValMax
	//	min_warning	not set for AvcValMax
	//	delta_t	not set for AvcValMax
	//	delta_val	not set for AvcValMax
	
	avcvalmax->set_default_properties(avcvalmax_prop);
	//	Not Polled
	avcvalmax->set_disp_level(Tango::OPERATOR);
	avcvalmax->set_memorized();
	avcvalmax->set_memorized_init(true);
	att_list.push_back(avcvalmax);

	//	Attribute : AgcValMin
	AgcValMinAttrib	*agcvalmin = new AgcValMinAttrib();
	Tango::UserDefaultAttrProp	agcvalmin_prop;
	//	description	not set for AgcValMin
	//	label	not set for AgcValMin
	//	unit	not set for AgcValMin
	//	standard_unit	not set for AgcValMin
	//	display_unit	not set for AgcValMin
	agcvalmin_prop.set_format("%.0f");
	agcvalmin_prop.set_max_value("63");
	agcvalmin_prop.set_min_value("0");
	//	max_alarm	not set for AgcValMin
	//	min_alarm	not set for AgcValMin
	//	max_warning	not set for AgcValMin
	//	min_warning	not set for AgcValMin
	//	delta_t	not set for AgcValMin
	//	delta_val	not set for AgcValMin
	
	agcvalmin->set_default_properties(agcvalmin_prop);
	//	Not Polled
	agcvalmin->set_disp_level(Tango::OPERATOR);
	agcvalmin->set_memorized();
	agcvalmin->set_memorized_init(true);
	att_list.push_back(agcvalmin);

	//	Attribute : AgcValMax
	AgcValMaxAttrib	*agcvalmax = new AgcValMaxAttrib();
	Tango::UserDefaultAttrProp	agcvalmax_prop;
	//	description	not set for AgcValMax
	//	label	not set for AgcValMax
	//	unit	not set for AgcValMax
	//	standard_unit	not set for AgcValMax
	//	display_unit	not set for AgcValMax
	agcvalmax_prop.set_format("%.0f");
	agcvalmax_prop.set_max_value("63");
	agcvalmax_prop.set_min_value("0");
	//	max_alarm	not set for AgcValMax
	//	min_alarm	not set for AgcValMax
	//	max_warning	not set for AgcValMax
	//	min_warning	not set for AgcValMax
	//	delta_t	not set for AgcValMax
	//	delta_val	not set for AgcValMax
	
	agcvalmax->set_default_properties(agcvalmax_prop);
	//	Not Polled
	agcvalmax->set_disp_level(Tango::OPERATOR);
	agcvalmax->set_memorized();
	agcvalmax->set_memorized_init(true);
	att_list.push_back(agcvalmax);

	//	Attribute : Gain
	GainAttrib	*gain = new GainAttrib();
	Tango::UserDefaultAttrProp	gain_prop;
	//	description	not set for Gain
	//	label	not set for Gain
	//	unit	not set for Gain
	//	standard_unit	not set for Gain
	//	display_unit	not set for Gain
	gain_prop.set_format("%.0f");
	gain_prop.set_max_value("63");
	gain_prop.set_min_value("0");
	//	max_alarm	not set for Gain
	//	min_alarm	not set for Gain
	//	max_warning	not set for Gain
	//	min_warning	not set for Gain
	//	delta_t	not set for Gain
	//	delta_val	not set for Gain
	
	gain->set_default_properties(gain_prop);
	//	Not Polled
	gain->set_disp_level(Tango::OPERATOR);
	gain->set_memorized();
	gain->set_memorized_init(true);
	att_list.push_back(gain);

	//	Attribute : CbpmFel01States
	CbpmFel01StatesAttrib	*cbpmfel01states = new CbpmFel01StatesAttrib();
	Tango::UserDefaultAttrProp	cbpmfel01states_prop;
	//	description	not set for CbpmFel01States
	//	label	not set for CbpmFel01States
	//	unit	not set for CbpmFel01States
	//	standard_unit	not set for CbpmFel01States
	//	display_unit	not set for CbpmFel01States
	//	format	not set for CbpmFel01States
	//	max_value	not set for CbpmFel01States
	//	min_value	not set for CbpmFel01States
	//	max_alarm	not set for CbpmFel01States
	//	min_alarm	not set for CbpmFel01States
	//	max_warning	not set for CbpmFel01States
	//	min_warning	not set for CbpmFel01States
	//	delta_t	not set for CbpmFel01States
	//	delta_val	not set for CbpmFel01States
	
	cbpmfel01states->set_default_properties(cbpmfel01states_prop);
	//	Not Polled
	cbpmfel01states->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(cbpmfel01states);

	//	Attribute : CbpmFel02States
	CbpmFel02StatesAttrib	*cbpmfel02states = new CbpmFel02StatesAttrib();
	Tango::UserDefaultAttrProp	cbpmfel02states_prop;
	//	description	not set for CbpmFel02States
	//	label	not set for CbpmFel02States
	//	unit	not set for CbpmFel02States
	//	standard_unit	not set for CbpmFel02States
	//	display_unit	not set for CbpmFel02States
	//	format	not set for CbpmFel02States
	//	max_value	not set for CbpmFel02States
	//	min_value	not set for CbpmFel02States
	//	max_alarm	not set for CbpmFel02States
	//	min_alarm	not set for CbpmFel02States
	//	max_warning	not set for CbpmFel02States
	//	min_warning	not set for CbpmFel02States
	//	delta_t	not set for CbpmFel02States
	//	delta_val	not set for CbpmFel02States
	
	cbpmfel02states->set_default_properties(cbpmfel02states_prop);
	//	Not Polled
	cbpmfel02states->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(cbpmfel02states);

	//	Attribute : BpmFel01States
	BpmFel01StatesAttrib	*bpmfel01states = new BpmFel01StatesAttrib();
	Tango::UserDefaultAttrProp	bpmfel01states_prop;
	//	description	not set for BpmFel01States
	//	label	not set for BpmFel01States
	//	unit	not set for BpmFel01States
	//	standard_unit	not set for BpmFel01States
	//	display_unit	not set for BpmFel01States
	//	format	not set for BpmFel01States
	//	max_value	not set for BpmFel01States
	//	min_value	not set for BpmFel01States
	//	max_alarm	not set for BpmFel01States
	//	min_alarm	not set for BpmFel01States
	//	max_warning	not set for BpmFel01States
	//	min_warning	not set for BpmFel01States
	//	delta_t	not set for BpmFel01States
	//	delta_val	not set for BpmFel01States
	
	bpmfel01states->set_default_properties(bpmfel01states_prop);
	//	Not Polled
	bpmfel01states->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(bpmfel01states);

	//	Attribute : BpmFel02States
	BpmFel02StatesAttrib	*bpmfel02states = new BpmFel02StatesAttrib();
	Tango::UserDefaultAttrProp	bpmfel02states_prop;
	//	description	not set for BpmFel02States
	//	label	not set for BpmFel02States
	//	unit	not set for BpmFel02States
	//	standard_unit	not set for BpmFel02States
	//	display_unit	not set for BpmFel02States
	//	format	not set for BpmFel02States
	//	max_value	not set for BpmFel02States
	//	min_value	not set for BpmFel02States
	//	max_alarm	not set for BpmFel02States
	//	min_alarm	not set for BpmFel02States
	//	max_warning	not set for BpmFel02States
	//	min_warning	not set for BpmFel02States
	//	delta_t	not set for BpmFel02States
	//	delta_val	not set for BpmFel02States
	
	bpmfel02states->set_default_properties(bpmfel02states_prop);
	//	Not Polled
	bpmfel02states->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(bpmfel02states);

	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(CbpmMasterClass::attribute_factory_after) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	CbpmMasterClass::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : CbpmMasterClass::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void CbpmMasterClass::command_factory()
{
	/*----- PROTECTED REGION ID(CbpmMasterClass::command_factory_before) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	CbpmMasterClass::command_factory_before


	//	Command ForceFel01
	ForceFel01Class	*pForceFel01Cmd =
		new ForceFel01Class("ForceFel01",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pForceFel01Cmd);

	//	Command ForceFel02
	ForceFel02Class	*pForceFel02Cmd =
		new ForceFel02Class("ForceFel02",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pForceFel02Cmd);

	//	Command GetCbpmFel01Names
	GetCbpmFel01NamesClass	*pGetCbpmFel01NamesCmd =
		new GetCbpmFel01NamesClass("GetCbpmFel01Names",
			Tango::DEV_VOID, Tango::DEVVAR_STRINGARRAY,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pGetCbpmFel01NamesCmd);

	//	Command GetCbpmFel02Names
	GetCbpmFel02NamesClass	*pGetCbpmFel02NamesCmd =
		new GetCbpmFel02NamesClass("GetCbpmFel02Names",
			Tango::DEV_VOID, Tango::DEVVAR_STRINGARRAY,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pGetCbpmFel02NamesCmd);

	//	Command GetBpmFel01Names
	GetBpmFel01NamesClass	*pGetBpmFel01NamesCmd =
		new GetBpmFel01NamesClass("GetBpmFel01Names",
			Tango::DEV_VOID, Tango::DEVVAR_STRINGARRAY,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pGetBpmFel01NamesCmd);

	//	Command GetBpmFel02Names
	GetBpmFel02NamesClass	*pGetBpmFel02NamesCmd =
		new GetBpmFel02NamesClass("GetBpmFel02Names",
			Tango::DEV_VOID, Tango::DEVVAR_STRINGARRAY,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pGetBpmFel02NamesCmd);

	/*----- PROTECTED REGION ID(CbpmMasterClass::command_factory_after) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	CbpmMasterClass::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		CbpmMasterClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list 
 */
//--------------------------------------------------------
void CbpmMasterClass::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(CbpmMasterClass::create_static_att_list) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	CbpmMasterClass::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		CbpmMasterClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void CbpmMasterClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{	
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		CbpmMaster *dev = static_cast<CbpmMaster *> (dev_impl);
		
		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(CbpmMasterClass::erase_dynamic_attributes) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	CbpmMasterClass::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : CbpmMasterClass::get_attr_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *CbpmMasterClass::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; it++)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(CbpmMasterClass::Additional Methods) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	CbpmMasterClass::Additional Methods
} //	namespace
