/*----- PROTECTED REGION ID(CbpmMasterClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        CbpmMasterClass.h
//
// description : Include for the CbpmMasterClass root class.
//               This class is the singleton class for.
//               the CbpmMaster device class..
//               It contains all properties and methods which the .
//               CbpmMaster requires only once e.g. the commands.
//
// project :     Cbpm Master.
//
// $Author: giulio $
//
// $Revision: 1.3 $
// $Date: 2018-04-24 15:32:51 $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source: /home/cvsadm/cvsroot/fermi/servers/cbpmmaster/src/CbpmMasterClass.h,v $
// $Log: CbpmMasterClass.h,v $
// Revision 1.3  2018-04-24 15:32:51  giulio
// Added Agc/Avc decimation values
//
// Revision 1.2  2014-05-05 07:33:57  giulio
// Added rtbpm switch
//
// Revision 1.1.1.1  2012-04-16 12:45:50  giulio
// First release
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef CBPMMASTERCLASS_H
#define CBPMMASTERCLASS_H

#include <tango.h>
#include <CbpmMaster.h>

/*----- PROTECTED REGION END -----*/	//	CbpmMasterClass.h


namespace CbpmMaster_ns
{
/*----- PROTECTED REGION ID(CbpmMasterClass::classes for dynamic creation) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	CbpmMasterClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute Enabled class definition
class EnabledAttrib: public Tango::Attr
{
public:
	EnabledAttrib():Attr("Enabled",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~EnabledAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CbpmMaster *>(dev))->read_Enabled(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CbpmMaster *>(dev))->write_Enabled(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CbpmMaster *>(dev))->is_Enabled_allowed(ty);}
};

//	Attribute Fel01 class definition
class Fel01Attrib: public Tango::Attr
{
public:
	Fel01Attrib():Attr("Fel01",
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~Fel01Attrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CbpmMaster *>(dev))->read_Fel01(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CbpmMaster *>(dev))->is_Fel01_allowed(ty);}
};

//	Attribute Fel02 class definition
class Fel02Attrib: public Tango::Attr
{
public:
	Fel02Attrib():Attr("Fel02",
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~Fel02Attrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CbpmMaster *>(dev))->read_Fel02(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CbpmMaster *>(dev))->is_Fel02_allowed(ty);}
};

//	Attribute AvcValMin class definition
class AvcValMinAttrib: public Tango::Attr
{
public:
	AvcValMinAttrib():Attr("AvcValMin",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AvcValMinAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CbpmMaster *>(dev))->read_AvcValMin(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CbpmMaster *>(dev))->write_AvcValMin(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CbpmMaster *>(dev))->is_AvcValMin_allowed(ty);}
};

//	Attribute AvcValMax class definition
class AvcValMaxAttrib: public Tango::Attr
{
public:
	AvcValMaxAttrib():Attr("AvcValMax",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AvcValMaxAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CbpmMaster *>(dev))->read_AvcValMax(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CbpmMaster *>(dev))->write_AvcValMax(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CbpmMaster *>(dev))->is_AvcValMax_allowed(ty);}
};

//	Attribute AgcValMin class definition
class AgcValMinAttrib: public Tango::Attr
{
public:
	AgcValMinAttrib():Attr("AgcValMin",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AgcValMinAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CbpmMaster *>(dev))->read_AgcValMin(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CbpmMaster *>(dev))->write_AgcValMin(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CbpmMaster *>(dev))->is_AgcValMin_allowed(ty);}
};

//	Attribute AgcValMax class definition
class AgcValMaxAttrib: public Tango::Attr
{
public:
	AgcValMaxAttrib():Attr("AgcValMax",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AgcValMaxAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CbpmMaster *>(dev))->read_AgcValMax(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CbpmMaster *>(dev))->write_AgcValMax(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CbpmMaster *>(dev))->is_AgcValMax_allowed(ty);}
};

//	Attribute Gain class definition
class GainAttrib: public Tango::Attr
{
public:
	GainAttrib():Attr("Gain",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~GainAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CbpmMaster *>(dev))->read_Gain(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CbpmMaster *>(dev))->write_Gain(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CbpmMaster *>(dev))->is_Gain_allowed(ty);}
};

//	Attribute CbpmFel01States class definition
class CbpmFel01StatesAttrib: public Tango::SpectrumAttr
{
public:
	CbpmFel01StatesAttrib():SpectrumAttr("CbpmFel01States",
			Tango::DEV_STATE, Tango::READ, 50) {};
	~CbpmFel01StatesAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CbpmMaster *>(dev))->read_CbpmFel01States(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CbpmMaster *>(dev))->is_CbpmFel01States_allowed(ty);}
};

//	Attribute CbpmFel02States class definition
class CbpmFel02StatesAttrib: public Tango::SpectrumAttr
{
public:
	CbpmFel02StatesAttrib():SpectrumAttr("CbpmFel02States",
			Tango::DEV_STATE, Tango::READ, 50) {};
	~CbpmFel02StatesAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CbpmMaster *>(dev))->read_CbpmFel02States(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CbpmMaster *>(dev))->is_CbpmFel02States_allowed(ty);}
};

//	Attribute BpmFel01States class definition
class BpmFel01StatesAttrib: public Tango::SpectrumAttr
{
public:
	BpmFel01StatesAttrib():SpectrumAttr("BpmFel01States",
			Tango::DEV_STATE, Tango::READ, 50) {};
	~BpmFel01StatesAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CbpmMaster *>(dev))->read_BpmFel01States(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CbpmMaster *>(dev))->is_BpmFel01States_allowed(ty);}
};

//	Attribute BpmFel02States class definition
class BpmFel02StatesAttrib: public Tango::SpectrumAttr
{
public:
	BpmFel02StatesAttrib():SpectrumAttr("BpmFel02States",
			Tango::DEV_STATE, Tango::READ, 50) {};
	~BpmFel02StatesAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CbpmMaster *>(dev))->read_BpmFel02States(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CbpmMaster *>(dev))->is_BpmFel02States_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command ForceFel01 class definition
class ForceFel01Class : public Tango::Command
{
public:
	ForceFel01Class(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ForceFel01Class(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ForceFel01Class() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CbpmMaster *>(dev))->is_ForceFel01_allowed(any);}
};

//	Command ForceFel02 class definition
class ForceFel02Class : public Tango::Command
{
public:
	ForceFel02Class(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ForceFel02Class(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ForceFel02Class() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CbpmMaster *>(dev))->is_ForceFel02_allowed(any);}
};

//	Command GetCbpmFel01Names class definition
class GetCbpmFel01NamesClass : public Tango::Command
{
public:
	GetCbpmFel01NamesClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetCbpmFel01NamesClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetCbpmFel01NamesClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CbpmMaster *>(dev))->is_GetCbpmFel01Names_allowed(any);}
};

//	Command GetCbpmFel02Names class definition
class GetCbpmFel02NamesClass : public Tango::Command
{
public:
	GetCbpmFel02NamesClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetCbpmFel02NamesClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetCbpmFel02NamesClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CbpmMaster *>(dev))->is_GetCbpmFel02Names_allowed(any);}
};

//	Command GetBpmFel01Names class definition
class GetBpmFel01NamesClass : public Tango::Command
{
public:
	GetBpmFel01NamesClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetBpmFel01NamesClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetBpmFel01NamesClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CbpmMaster *>(dev))->is_GetBpmFel01Names_allowed(any);}
};

//	Command GetBpmFel02Names class definition
class GetBpmFel02NamesClass : public Tango::Command
{
public:
	GetBpmFel02NamesClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetBpmFel02NamesClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetBpmFel02NamesClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CbpmMaster *>(dev))->is_GetBpmFel02Names_allowed(any);}
};


/**
 *	The CbpmMasterClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  CbpmMasterClass : public Tango::DeviceClass
#else
class CbpmMasterClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(CbpmMasterClass::Additionnal DServer data members) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	CbpmMasterClass::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static CbpmMasterClass *init(const char *);
		static CbpmMasterClass *instance();
		~CbpmMasterClass();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		CbpmMasterClass(string &);
		static CbpmMasterClass *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	CbpmMaster_H
