/*----- PROTECTED REGION ID(CbpmMasterStateMachine.cpp) ENABLED START -----*/
static const char *RcsId = "$Id: CbpmMasterStateMachine.cpp,v 1.3 2018-04-24 15:32:51 giulio Exp $";
//=============================================================================
//
// file :        CbpmMasterStateMachine.cpp
//
// description : C++ source for the CbpmMaster and its alowed
//               methods for commands and attributes
//
// project :     Cbpm Master.
//
// $Author: giulio $
//
// $Revision: 1.3 $
// $Date: 2018-04-24 15:32:51 $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source: /home/cvsadm/cvsroot/fermi/servers/cbpmmaster/src/CbpmMasterStateMachine.cpp,v $
// $Log: CbpmMasterStateMachine.cpp,v $
// Revision 1.3  2018-04-24 15:32:51  giulio
// Added Agc/Avc decimation values
//
// Revision 1.2  2014-05-05 07:33:57  giulio
// Added rtbpm switch
//
// Revision 1.1.1.1  2012-04-16 12:45:50  giulio
// First release
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================



#include <CbpmMaster.h>
#include <CbpmMasterClass.h>

/*----- PROTECTED REGION END -----*/	//	CbpmMaster::CbpmMasterStateMachine.cpp

//================================================================
//  States  |  Description
//================================================================
//  ON      |  Automatic loop is enabled
//  OFF     |  Automatic loop is disabled
//  FAULT   |  Errors from devices


namespace CbpmMaster_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : CbpmMaster::is_Enabled_allowed()
 *	Description : Execution allowed for Enabled attribute
 */
//--------------------------------------------------------
bool CbpmMaster::is_Enabled_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Enabled attribute in Write access.
	/*----- PROTECTED REGION ID(CbpmMaster::EnabledStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	CbpmMaster::EnabledStateAllowed_WRITE

	//	Not any excluded states for Enabled attribute in read access.
	/*----- PROTECTED REGION ID(CbpmMaster::EnabledStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CbpmMaster::EnabledStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CbpmMaster::is_Fel01_allowed()
 *	Description : Execution allowed for Fel01 attribute
 */
//--------------------------------------------------------
bool CbpmMaster::is_Fel01_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Fel01 attribute in read access.
	/*----- PROTECTED REGION ID(CbpmMaster::Fel01StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CbpmMaster::Fel01StateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CbpmMaster::is_Fel02_allowed()
 *	Description : Execution allowed for Fel02 attribute
 */
//--------------------------------------------------------
bool CbpmMaster::is_Fel02_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Fel02 attribute in read access.
	/*----- PROTECTED REGION ID(CbpmMaster::Fel02StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CbpmMaster::Fel02StateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CbpmMaster::is_AvcValMin_allowed()
 *	Description : Execution allowed for AvcValMin attribute
 */
//--------------------------------------------------------
bool CbpmMaster::is_AvcValMin_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AvcValMin attribute in Write access.
	/*----- PROTECTED REGION ID(CbpmMaster::AvcValMinStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CbpmMaster::AvcValMinStateAllowed_WRITE

	//	Not any excluded states for AvcValMin attribute in read access.
	/*----- PROTECTED REGION ID(CbpmMaster::AvcValMinStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CbpmMaster::AvcValMinStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CbpmMaster::is_AvcValMax_allowed()
 *	Description : Execution allowed for AvcValMax attribute
 */
//--------------------------------------------------------
bool CbpmMaster::is_AvcValMax_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AvcValMax attribute in Write access.
	/*----- PROTECTED REGION ID(CbpmMaster::AvcValMaxStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CbpmMaster::AvcValMaxStateAllowed_WRITE

	//	Not any excluded states for AvcValMax attribute in read access.
	/*----- PROTECTED REGION ID(CbpmMaster::AvcValMaxStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CbpmMaster::AvcValMaxStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CbpmMaster::is_AgcValMin_allowed()
 *	Description : Execution allowed for AgcValMin attribute
 */
//--------------------------------------------------------
bool CbpmMaster::is_AgcValMin_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AgcValMin attribute in Write access.
	/*----- PROTECTED REGION ID(CbpmMaster::AgcValMinStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CbpmMaster::AgcValMinStateAllowed_WRITE

	//	Not any excluded states for AgcValMin attribute in read access.
	/*----- PROTECTED REGION ID(CbpmMaster::AgcValMinStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CbpmMaster::AgcValMinStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CbpmMaster::is_AgcValMax_allowed()
 *	Description : Execution allowed for AgcValMax attribute
 */
//--------------------------------------------------------
bool CbpmMaster::is_AgcValMax_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AgcValMax attribute in Write access.
	/*----- PROTECTED REGION ID(CbpmMaster::AgcValMaxStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CbpmMaster::AgcValMaxStateAllowed_WRITE

	//	Not any excluded states for AgcValMax attribute in read access.
	/*----- PROTECTED REGION ID(CbpmMaster::AgcValMaxStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CbpmMaster::AgcValMaxStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CbpmMaster::is_Gain_allowed()
 *	Description : Execution allowed for Gain attribute
 */
//--------------------------------------------------------
bool CbpmMaster::is_Gain_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Gain attribute in Write access.
	/*----- PROTECTED REGION ID(CbpmMaster::GainStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CbpmMaster::GainStateAllowed_WRITE

	//	Not any excluded states for Gain attribute in read access.
	/*----- PROTECTED REGION ID(CbpmMaster::GainStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CbpmMaster::GainStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CbpmMaster::is_CbpmFel01States_allowed()
 *	Description : Execution allowed for CbpmFel01States attribute
 */
//--------------------------------------------------------
bool CbpmMaster::is_CbpmFel01States_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for CbpmFel01States attribute in read access.
	/*----- PROTECTED REGION ID(CbpmMaster::CbpmFel01StatesStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CbpmMaster::CbpmFel01StatesStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CbpmMaster::is_CbpmFel02States_allowed()
 *	Description : Execution allowed for CbpmFel02States attribute
 */
//--------------------------------------------------------
bool CbpmMaster::is_CbpmFel02States_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for CbpmFel02States attribute in read access.
	/*----- PROTECTED REGION ID(CbpmMaster::CbpmFel02StatesStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CbpmMaster::CbpmFel02StatesStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CbpmMaster::is_BpmFel01States_allowed()
 *	Description : Execution allowed for BpmFel01States attribute
 */
//--------------------------------------------------------
bool CbpmMaster::is_BpmFel01States_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for BpmFel01States attribute in read access.
	/*----- PROTECTED REGION ID(CbpmMaster::BpmFel01StatesStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CbpmMaster::BpmFel01StatesStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CbpmMaster::is_BpmFel02States_allowed()
 *	Description : Execution allowed for BpmFel02States attribute
 */
//--------------------------------------------------------
bool CbpmMaster::is_BpmFel02States_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for BpmFel02States attribute in read access.
	/*----- PROTECTED REGION ID(CbpmMaster::BpmFel02StatesStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CbpmMaster::BpmFel02StatesStateAllowed_READ
	return true;
}

//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : CbpmMaster::is_ForceFel01_allowed()
 *	Description : Execution allowed for ForceFel01 attribute
 */
//--------------------------------------------------------
bool CbpmMaster::is_ForceFel01_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for ForceFel01 command.
	/*----- PROTECTED REGION ID(CbpmMaster::ForceFel01StateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	CbpmMaster::ForceFel01StateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CbpmMaster::is_ForceFel02_allowed()
 *	Description : Execution allowed for ForceFel02 attribute
 */
//--------------------------------------------------------
bool CbpmMaster::is_ForceFel02_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for ForceFel02 command.
	/*----- PROTECTED REGION ID(CbpmMaster::ForceFel02StateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	CbpmMaster::ForceFel02StateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CbpmMaster::is_GetCbpmFel01Names_allowed()
 *	Description : Execution allowed for GetCbpmFel01Names attribute
 */
//--------------------------------------------------------
bool CbpmMaster::is_GetCbpmFel01Names_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetCbpmFel01Names command.
	/*----- PROTECTED REGION ID(CbpmMaster::GetCbpmFel01NamesStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	CbpmMaster::GetCbpmFel01NamesStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CbpmMaster::is_GetCbpmFel02Names_allowed()
 *	Description : Execution allowed for GetCbpmFel02Names attribute
 */
//--------------------------------------------------------
bool CbpmMaster::is_GetCbpmFel02Names_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetCbpmFel02Names command.
	/*----- PROTECTED REGION ID(CbpmMaster::GetCbpmFel02NamesStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	CbpmMaster::GetCbpmFel02NamesStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CbpmMaster::is_GetBpmFel01Names_allowed()
 *	Description : Execution allowed for GetBpmFel01Names attribute
 */
//--------------------------------------------------------
bool CbpmMaster::is_GetBpmFel01Names_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetBpmFel01Names command.
	/*----- PROTECTED REGION ID(CbpmMaster::GetBpmFel01NamesStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CbpmMaster::GetBpmFel01NamesStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CbpmMaster::is_GetBpmFel02Names_allowed()
 *	Description : Execution allowed for GetBpmFel02Names attribute
 */
//--------------------------------------------------------
bool CbpmMaster::is_GetBpmFel02Names_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetBpmFel02Names command.
	/*----- PROTECTED REGION ID(CbpmMaster::GetBpmFel02NamesStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CbpmMaster::GetBpmFel02NamesStateAllowed
	return true;
}

}	//	End of namespace
