/*PROTECTED REGION ID(CbpmMaster::main.cpp) ENABLED START*/
static const char *RcsId = "$Id: main.cpp,v 1.2 2014-05-05 07:33:57 giulio Exp $";
//=============================================================================
//
// file :        CbpmMaster.cpp
//
// description : C++ source for the CbpmMaster device server main.
//               The main rule is to initialise (and create) the Tango
//               system and to create the DServerClass singleton.
//                The main should be the same for every Tango device server.
//
// project :     Cbpm Master.
//
// $Author: giulio $
//
// $Revision: 1.2 $
// $Date: 2014-05-05 07:33:57 $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source: /home/cvsadm/cvsroot/fermi/servers/cbpmmaster/src/main.cpp,v $
// $Log: main.cpp,v $
// Revision 1.2  2014-05-05 07:33:57  giulio
// Added rtbpm switch
//
// Revision 1.1.1.1  2012-04-16 12:45:50  giulio
// First release
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <tango.h>


int main(int argc,char *argv[])
{
	Tango::Util *tg;
	Tango::Util::_daemon = true;
	Tango::Util::_sleep_between_connect = 10;	
	
	try
	{
		// Initialise the device server
		//----------------------------------------
		tg = Tango::Util::init(argc,argv);

		// Create the device server singleton 
		//	which will create everything
		//----------------------------------------
		tg->server_init(false);

		// Run the endless loop
		//----------------------------------------
		cout << "Ready to accept request" << endl;
		tg->server_run();
	}
	catch (bad_alloc)
	{
		cout << "Can't allocate memory to store device object !!!" << endl;
		cout << "Exiting" << endl;
	}
	catch (CORBA::Exception &e)
	{
		Tango::Except::print_exception(e);
		
		cout << "Received a CORBA_Exception" << endl;
		cout << "Exiting" << endl;
	}
	if (tg!=NULL)
		tg->server_cleanup();
	return(0);
}
/*PROTECTED REGION END*/	//	CbpmMaster::main.cpp
